"""
Copyright (C) Cross The Road Electronics.  All rights reserved.
License information can be found in CTRE_LICENSE.txt
For support and suggestions contact support@ctr-electronics.com or file
an issue tracker at https://github.com/CrossTheRoadElec/Phoenix-Releases
"""

from enum import Enum

class SpnValue(Enum):
    TALON_FX_SYSTEM_STATE = 614
    STARTUP_RESET_FLAGS = 635
    VERSION_MAJOR = 733
    VERSION_MINOR = 734
    VERSION_BUGFIX = 735
    VERSION_BUILD = 736
    VERSION_FULL = 737
    LICENSING_IS_PRO_LICENSED = 750
    LICENSING_IS_SEASON_PASSED = 753
    CUSTOM_PARAM0 = 822
    CUSTOM_PARAM1 = 823
    CANCODER_SENSOR_DIRECTION = 827
    FRC_LOCK = 829
    ROBOT_ENABLED = 830
    LED1_ON_COLOR = 832
    LED1_OFF_COLOR = 833
    LED2_ON_COLOR = 834
    LED2_OFF_COLOR = 835
    ALL_FAULTS = 841
    ALL_STICKY_FAULTS = 842
    PIGEON2_USE_COMPASS = 916
    PIGEON2_DISABLE_TEMPERATURE_COMPENSATION = 951
    PIGEON2_DISABLE_NO_MOTION_CALIBRATION = 953
    PIGEON2_MOUNT_POSE_YAW = 958
    PIGEON2_MOUNT_POSE_PITCH = 959
    PIGEON2_MOUNT_POSE_ROLL = 960
    PIGEON2_GYRO_SCALAR_X = 964
    PIGEON2_GYRO_SCALAR_Y = 965
    PIGEON2_GYRO_SCALAR_Z = 966
    PIGEON2_YAW = 973
    PIGEON2_PITCH = 974
    PIGEON2_ROLL = 975
    PIGEON2_QUAT_W = 976
    PIGEON2_QUAT_X = 977
    PIGEON2_QUAT_Y = 978
    PIGEON2_QUAT_Z = 979
    PIGEON2_GRAVITY_VECTOR_X = 980
    PIGEON2_GRAVITY_VECTOR_Y = 981
    PIGEON2_GRAVITY_VECTOR_Z = 982
    PIGEON2_TEMPERATURE = 983
    PIGEON2_NO_MOTION_CAL_ENABLED = 984
    PIGEON2_NO_MOTION_COUNT = 985
    PIGEON2_TEMP_COMP_DISABLED = 986
    PIGEON2_UP_TIME = 987
    PIGEON2_ACCUM_GYRO_X = 988
    PIGEON2_ACCUM_GYRO_Y = 989
    PIGEON2_ACCUM_GYRO_Z = 990
    PIGEON2_ANGULAR_VELOCITY_X_WORLD = 991
    PIGEON2_ANGULAR_VELOCITY_Y_WORLD = 992
    PIGEON2_ANGULAR_VELOCITY_Z_WORLD = 993
    PIGEON2_ACCELERATION_X = 994
    PIGEON2_ACCELERATION_Y = 995
    PIGEON2_ACCELERATION_Z = 996
    PIGEON2_SUPPLY_VOLTAGE = 997
    PIGEON2_ANGULAR_VELOCITY_X = 1000
    PIGEON2_ANGULAR_VELOCITY_Y = 1001
    PIGEON2_ANGULAR_VELOCITY_Z = 1002
    PIGEON2_MAGNETIC_FIELD_X = 1005
    PIGEON2_MAGNETIC_FIELD_Y = 1006
    PIGEON2_MAGNETIC_FIELD_Z = 1007
    PIGEON2_RAW_MAGNETIC_FIELD_X = 1008
    PIGEON2_RAW_MAGNETIC_FIELD_Y = 1009
    PIGEON2_RAW_MAGNETIC_FIELD_Z = 1010
    CAN_CODER_MAGNET_OFFSET = 1011
    TALON_FX_SET_SENSOR_POSITION = 1016
    CANCODER_SET_SENSOR_POSITION = 1018
    PIGEON2_SET_YAW = 1020
    DEVICE_ENABLED = 1049
    PRO_MOTOR_OUTPUT_MOTOR_VOLTAGE = 2028
    FORWARD_LIMIT = 2029
    REVERSE_LIMIT = 2030
    PRO_MOTOR_OUTPUT_ROTOR_POLARITY = 2031
    PRO_MOTOR_OUTPUT_DUTY_CYCLE = 2032
    PRO_MOTOR_OUTPUT_TORQUE_CURRENT = 2034
    PRO_SUPPLY_AND_TEMP_STATOR_CURRENT = 2035
    PRO_SUPPLY_AND_TEMP_SUPPLY_CURRENT = 2036
    PRO_SUPPLY_AND_TEMP_SUPPLY_VOLTAGE = 2037
    PRO_SUPPLY_AND_TEMP_DEVICE_TEMP = 2038
    PRO_SUPPLY_AND_TEMP_PROCESSOR_TEMP = 2039
    PRO_ROTOR_POS_AND_VEL_VELOCITY = 2041
    PRO_ROTOR_POS_AND_VEL_POSITION = 2042
    PRO_POS_AND_VEL_VELOCITY = 2045
    PRO_POS_AND_VEL_POSITION = 2046
    PRO_POS_AND_VEL_ACCELERATION = 2047
    PRO_PID_STATE_ENABLES_INTEGRATED_ACCUM_DC = 2049
    PRO_PID_STATE_ENABLES_INTEGRATED_ACCUM_V = 2050
    PRO_PID_STATE_ENABLES_INTEGRATED_ACCUM_A = 2051
    PRO_PID_STATE_ENABLES_FEED_FORWARD_DC = 2052
    PRO_PID_STATE_ENABLES_FEED_FORWARD_V = 2053
    PRO_PID_STATE_ENABLES_FEED_FORWARD_A = 2054
    TALON_FX_CONTROL_MODE = 2055
    EXTERNAL_MOTOR_TEMP_STATUS = 2056
    EXTERNAL_MOTOR_TEMP = 2057
    PRO_PID_STATE_ENABLES_IS_MOTION_MAGIC_RUNNING = 2061
    PRO_PID_STATE_ENABLES_ROBOT_ENABLE = 2062
    PRO_PID_STATE_ENABLES_DEVICE_ENABLE = 2063
    PRO_PID_REF_PID_ERR_PID_REF_POSITION = 2065
    PRO_PID_REF_PID_ERR_PID_REF_VELOCITY = 2066
    PRO_PID_REF_PID_ERR_PID_ERR_POSITION = 2067
    PRO_PID_REF_PID_ERR_PID_ERR_VELOCITY = 2068
    PRO_PID_REF_PID_ERR_CLOSED_LOOP_MODE = 2069
    PRO_PID_OUTPUT_PID_OUTPUT_MODE = 2071
    PRO_PID_OUTPUT_PROPORTIONAL_OUTPUT_DC = 2072
    PRO_PID_OUTPUT_PROPORTIONAL_OUTPUT_V = 2073
    PRO_PID_OUTPUT_PROPORTIONAL_OUTPUT_A = 2074
    PRO_PID_OUTPUT_DERIVATIVE_OUTPUT_DC = 2075
    PRO_PID_OUTPUT_DERIVATIVE_OUTPUT_V = 2076
    PRO_PID_OUTPUT_DERIVATIVE_OUTPUT_A = 2077
    PRO_PID_OUTPUT_OUTPUT_DC = 2078
    PRO_PID_OUTPUT_OUTPUT_V = 2079
    PRO_PID_OUTPUT_OUTPUT_A = 2080
    PRO_PID_OUTPUT_SLOT = 2081
    PRO_PID_REF_SLOPE_ECU_TIME_REFERENCE_SLOPE_POSITION = 2082
    PRO_PID_REF_SLOPE_ECU_TIME_REFERENCE_SLOPE_VELOCITY = 2083
    PRO_PID_REF_SLOPE_ECU_TIME_CLOSED_LOOP_MODE = 2084
    TALON_FX_MOTOR_OUTPUT_STATUS = 2085
    PRO_MOTOR_OUTPUT_PID_STATE_DIFF_DUTY_CYCLE = 2088
    PRO_MOTOR_OUTPUT_PID_STATE_DIFF_TORQUE_CURRENT = 2089
    TALON_FX_DIFFERENTIAL_CONTROL_MODE = 2092
    PRO_MOTOR_OUTPUT_PID_STATE_DIFF_INTEGRATED_ACCUM_DC = 2093
    PRO_MOTOR_OUTPUT_PID_STATE_DIFF_INTEGRATED_ACCUM_V = 2094
    PRO_MOTOR_OUTPUT_PID_STATE_DIFF_INTEGRATED_ACCUM_A = 2095
    PRO_MOTOR_OUTPUT_PID_STATE_DIFF_FEED_FORWARD_DC = 2096
    PRO_MOTOR_OUTPUT_PID_STATE_DIFF_FEED_FORWARD_V = 2097
    PRO_MOTOR_OUTPUT_PID_STATE_DIFF_FEED_FORWARD_A = 2098
    PRO_AVG_POS_AND_VEL_VELOCITY = 2100
    PRO_AVG_POS_AND_VEL_POSITION = 2101
    PRO_DIFF_POS_AND_VEL_VELOCITY = 2104
    PRO_DIFF_POS_AND_VEL_POSITION = 2105
    PRO_DIFF_PID_REF_PID_ERR_PID_REF_POSITION = 2107
    PRO_DIFF_PID_REF_PID_ERR_PID_REF_VELOCITY = 2108
    PRO_DIFF_PID_REF_PID_ERR_PID_ERR_POSITION = 2109
    PRO_DIFF_PID_REF_PID_ERR_PID_ERR_VELOCITY = 2110
    PRO_DIFF_PID_REF_PID_ERR_CLOSED_LOOP_MODE = 2111
    PRO_DIFF_PID_OUTPUT_PID_OUTPUT_MODE = 2113
    PRO_DIFF_PID_OUTPUT_PROPORTIONAL_OUTPUT_DC = 2114
    PRO_DIFF_PID_OUTPUT_PROPORTIONAL_OUTPUT_V = 2115
    PRO_DIFF_PID_OUTPUT_PROPORTIONAL_OUTPUT_A = 2116
    PRO_DIFF_PID_OUTPUT_DERIVATIVE_OUTPUT_DC = 2117
    PRO_DIFF_PID_OUTPUT_DERIVATIVE_OUTPUT_V = 2118
    PRO_DIFF_PID_OUTPUT_DERIVATIVE_OUTPUT_A = 2119
    PRO_DIFF_PID_OUTPUT_OUTPUT_DC = 2120
    PRO_DIFF_PID_OUTPUT_OUTPUT_V = 2121
    PRO_DIFF_PID_OUTPUT_OUTPUT_A = 2122
    PRO_DIFF_PID_OUTPUT_SLOT = 2123
    PRO_DIFF_PID_REF_SLOPE_ECU_TIME_REFERENCE_SLOPE_POSITION = 2124
    PRO_DIFF_PID_REF_SLOPE_ECU_TIME_REFERENCE_SLOPE_VELOCITY = 2125
    PRO_DIFF_PID_REF_SLOPE_ECU_TIME_CLOSED_LOOP_MODE = 2126
    TALON_FX_MOTOR_CONSTANTS_K_T = 2128
    TALON_FX_MOTOR_CONSTANTS_K_V = 2129
    TALON_FX_MOTOR_CONSTANTS_STALL_CURRENT = 2130
    SLOT0_K_P = 2131
    SLOT0_K_I = 2132
    SLOT0_K_D = 2133
    SLOT0_K_S = 2134
    SLOT0_K_V = 2135
    SLOT0_K_A = 2136
    SLOT0_K_G = 2137
    SLOT0_K_G_TYPE = 2138
    SLOT1_K_P = 2139
    SLOT1_K_I = 2140
    SLOT1_K_D = 2141
    SLOT1_K_S = 2142
    SLOT1_K_V = 2143
    SLOT1_K_A = 2144
    SLOT1_K_G = 2145
    SLOT1_K_G_TYPE = 2146
    SLOT2_K_P = 2147
    SLOT2_K_I = 2148
    SLOT2_K_D = 2149
    SLOT2_K_S = 2150
    SLOT2_K_V = 2151
    SLOT2_K_A = 2152
    SLOT2_K_G = 2153
    SLOT2_K_G_TYPE = 2154
    CONFIG_INVERTED = 2155
    CONFIG_SUPPLY_V_LOWPASS_TAU = 2156
    CONFIG_BEEP_ON_BOOT = 2157
    CONFIG_NEUTRAL_MODE = 2158
    CONFIG_DUTY_CYCLE_NEUTRAL_DB = 2159
    CONFIG_STATOR_CURRENT_LIMIT = 2160
    CONFIG_STATOR_CURR_LIMIT_EN = 2161
    CONFIG_SUPPLY_CURRENT_LIMIT = 2162
    CONFIG_SUPPLY_CURR_LIMIT_EN = 2163
    CONFIG_PEAK_FORWARD_DC = 2164
    CONFIG_PEAK_REVERSE_DC = 2165
    CONFIG_PEAK_FORWARD_V = 2166
    CONFIG_PEAK_REVERSE_V = 2167
    CONFIG_PEAK_FOR_TORQ_CURR = 2168
    CONFIG_PEAK_REV_TORQ_CURR = 2169
    CONFIG_TORQUE_NEUTRAL_DB = 2170
    CONFIG_FEEDBACK_ROTOR_OFFSET = 2171
    CONFIG_SENSOR_TO_MECHANISM_RATIO = 2172
    CONFIG_ROTOR_TO_SENSOR_RATIO = 2173
    CONFIG_FEEDBACK_SENSOR_SOURCE = 2174
    CONFIG_FEEDBACK_REMOTE_SENSOR_ID = 2175
    CONFIG_DUTY_CYCLE_OPEN_LOOP_RAMP_PERIOD = 2176
    CONFIG_VOLTAGE_OPEN_LOOP_RAMP_PERIOD = 2177
    CONFIG_TORQUE_OPEN_LOOP_RAMP_PERIOD = 2178
    CONFIG_DUTY_CYCLE_CLOSED_LOOP_RAMP_PERIOD = 2179
    CONFIG_VOLTAGE_CLOSED_LOOP_RAMP_PERIOD = 2180
    CONFIG_TORQUE_CLOSED_LOOP_RAMP_PERIOD = 2181
    CONFIG_FORWARD_LIMIT_TYPE = 2182
    CONFIG_FORWARD_LIMIT_AUTOSET_POS_ENABLE = 2183
    CONFIG_FORWARD_LIMIT_AUTOSET_POS_VALUE = 2184
    CONFIG_FORWARD_LIMIT_ENABLE = 2185
    CONFIG_FORWARD_LIMIT_SOURCE = 2186
    CONFIG_FORWARD_LIMIT_REMOTE_SENSOR_ID = 2187
    CONFIG_REVERSE_LIMIT_TYPE = 2188
    CONFIG_REVERSE_LIMIT_AUTOSET_POS_ENABLE = 2189
    CONFIG_REVERSE_LIMIT_AUTOSET_POS_VALUE = 2190
    CONFIG_REVERSE_LIMIT_ENABLE = 2191
    CONFIG_REVERSE_LIMIT_SOURCE = 2192
    CONFIG_REVERSE_LIMIT_REMOTE_SENSOR_ID = 2193
    CONFIG_FORWARD_SOFT_LIMIT_ENABLE = 2194
    CONFIG_REVERSE_SOFT_LIMIT_ENABLE = 2195
    CONFIG_FORWARD_SOFT_LIMIT_THRESHOLD = 2196
    CONFIG_REVERSE_SOFT_LIMIT_THRESHOLD = 2197
    CONFIG_MOTION_MAGIC_CRUISE_VELOCITY = 2198
    CONFIG_MOTION_MAGIC_ACCELERATION = 2199
    CONFIG_MOTION_MAGIC_JERK = 2200
    CONFIG_MOTION_MAGIC_EXPO_K_V = 2201
    CONFIG_MOTION_MAGIC_EXPO_K_A = 2202
    CONFIG_PEAK_DIFF_DC = 2203
    CONFIG_PEAK_DIFF_V = 2204
    CONFIG_PEAK_DIFF_TORQ_CURR = 2205
    CANCODER_VELOCITY = 2206
    CANCODER_POSITION = 2207
    CANCODER_ABS_POSITION = 2208
    CAN_CODER_RAW_VEL = 2210
    CAN_CODER_RAW_POS = 2211
    CAN_CODER_SUPPLY_VOLTAGE = 2212
    CANCODER_MAG_HEALTH = 2213
    SPN_CLEAR_STICKY_FAULTS = 2216
    PRO_MOTOR_OUTPUT_BRIDGE_TYPE_PUBLIC = 2217
    CONFIG_CONTINUOUS_WRAP = 2239
    CONFIG_SUPPLY_CURRENT_LOWER_LIMIT = 2245
    CONFIG_SUPPLY_CURRENT_LOWER_TIME = 2246
    CONFIG_DIFFERENTIAL_SENSOR_SOURCE = 2260
    CONFIG_DIFFERENTIAL_TALON_FX_SENSOR_ID = 2261
    CONFIG_DIFFERENTIAL_REMOTE_SENSOR_ID = 2262
    CONFIG_BEEP_ON_CONFIG = 2301
    CONFIG_ALLOW_MUSIC_DUR_DISABLE = 2302
    COMPLIANCY_VERSION = 2303
    VERSION_IS_PRO_LICENSED = 2304
    PRO_SUPPLY_AND_TEMP_DEVICE_TEMP2 = 2343
    SLOT0_K_S_SIGN = 2366
    SLOT1_K_S_SIGN = 2367
    SLOT2_K_S_SIGN = 2368
    TALON_FX_CONNECTED_MOTOR = 2369
    CANRANGE_SUPPLY_VOLTAGE = 2391
    CANRANGE_DISTANCE_METERS = 2392
    CANRANGE_MEAS_TIME = 2394
    CANRANGE_SIGNAL_STRENGTH = 2395
    CANRANGE_PROXIMITY_DETECTED = 2396
    CANRANGE_MEAS_STATE = 2397
    CANRANGE_AMBIENT_SIGNAL = 2398
    CANRANGE_DISTANCE_STD_DEV = 2399
    CANRANGE_REAL_FOV_CENTER_X = 2402
    CANRANGE_REAL_FOV_CENTER_Y = 2403
    CANRANGE_REAL_FOV_RANGE_X = 2404
    CANRANGE_REAL_FOV_RANGE_Y = 2405
    CANRANGE_UPDATE_MODE = 2409
    CANRANGE_UPDATE_FREQ = 2410
    CANRANGE_PROXIMITY_THRESHOLD = 2412
    CANRANGE_PROXIMITY_HYSTERESIS = 2413
    CANRANGE_MIN_SIG_STRENGTH_FOR_VALID_MEAS = 2414
    CANRANGE_FOV_CENTER_X = 2415
    CANRANGE_FOV_CENTER_Y = 2416
    CANRANGE_FOV_RANGE_X = 2417
    CANRANGE_FOV_RANGE_Y = 2418
    CONFIG_CONTROL_TIMESYNC_FREQ = 2419
    CONFIG_VELOCITY_FILTER_TIME_CONSTANT = 2420
    CONFIG_ADVANCED_HALL_SUPPORT = 2617
    CONFIG_MOTOR_TYPE = 2618
    CANDI_PIN1_STATE = 2677
    CANDI_PIN2_STATE = 2678
    CANDI_QUAD_POSITION = 2679
    CANDI_PWM1_RISE_TO_RISE = 2685
    CANDI_PWM1_POSITION = 2686
    CANDI_PWM1_VELOCITY = 2688
    CANDI_PWM2_RISE_TO_RISE = 2689
    CANDI_PWM2_POSITION = 2690
    CANDI_OVERCURRENT = 2692
    CANDI_V_SENSE = 2693
    CANDI_OUTPUT_CURRENT = 2694
    CANDI_S1_FLOAT_STATE = 2695
    CANDI_S2_FLOAT_STATE = 2696
    CONFIG_ABSOLUTE_SENSOR_OFFSET = 2705
    CONFIG_EXTERNAL_FEEDBACK_SENSOR_SOURCE = 2706
    CONFIG_SENSOR_PHASE = 2707
    CONFIG_QUADRATURE_EDGES_PER_ROTATION = 2708
    CONFIG_ABSOLUTE_SENSOR_DISCONTINUITY_POINT = 2709
    CANDI_PWM2_VELOCITY = 2847
    TALON_FXS_5_V_RAIL_VOLTAGE = 2849
    TALON_FXS_GADGETEER_G3 = 2850
    CANDI_QUAD_VELOCITY = 2857
    CONFIG_PWM1_ABSOLUTE_SENSOR_OFFSET = 2858
    CONFIG_PWM1_ABSOLUTE_SENSOR_DISCONTINUITY_POINT = 2859
    CONFIG_PWM1_SENSOR_DIRECTION = 2860
    CONFIG_PWM2_ABSOLUTE_SENSOR_OFFSET = 2862
    CONFIG_PWM2_ABSOLUTE_SENSOR_DISCONTINUITY_POINT = 2863
    CONFIG_PWM2_SENSOR_DIRECTION = 2864
    CONFIG_QUAD_SENSOR_DIRECTION = 2866
    CANDI_SET_QUAD_POSITION = 2868
    CONFIG_S1_CLOSE_STATE = 2869
    CONFIG_S2_CLOSE_STATE = 2870
    CANDI_S1_CLOSED = 2871
    CANDI_S2_CLOSED = 2872
    CONFIG_BRUSHED_MOTOR_WIRING = 2878
    PRO_GADGETEER_QUAD_RAW_QUADRATURE_POSITION = 2885
    PRO_GADGETEER_QUAD_RAW_QUADRATURE_VELOCITY = 2886
    PRO_GADGETEER_PWM_RAW_PWM_POSITION = 2887
    PRO_GADGETEER_PWM_RAW_PWM_VELOCITY = 2888
    CANDLE_GENERAL_SUPPLY_VOLTAGE = 2899
    CANDLE_GENERAL_FIVE_V_RAIL_VOLTAGE = 2900
    CANDLE_GENERAL_OUTPUT_CURRENT = 2901
    CANDLE_GENERAL_DEVICE_TEMP = 2902
    CANDLE_GENERAL_V_BAT_MODULATION = 2903
    CANDLE_GENERAL_MAX_SIMUL_ANIM_COUNT = 2904
    CONFIG_LED_STRIP_TYPE = 2905
    CONFIG_LED_BRIGHTNESS_SCALAR = 2906
    CONFIG_LED_LOSS_OF_SIGNAL_BEHAVIOR = 2907
    CONFIG_CANDLE_5_V_RAIL = 2908
    CONFIG_CANDLE_V_BAT_OUTPUT_MODE = 2909
    CONFIG_CANDLE_STATUS_LED_WHEN_ACTIVE = 2910
    CANDLE_ANIMATION0_TYPE = 2927
    CANDLE_ANIMATION1_TYPE = 2928
    CANDLE_ANIMATION2_TYPE = 2929
    CANDLE_ANIMATION3_TYPE = 2930
    CANDLE_ANIMATION4_TYPE = 2931
    CANDLE_ANIMATION5_TYPE = 2932
    CANDLE_ANIMATION6_TYPE = 2933
    CANDLE_ANIMATION7_TYPE = 2934
    CANDLE_ANIMATION_DIRECTION = 2935
    CANDLE_LARSON_BOUNCE_MODE = 2936
    FAULT_HARDWARE = 10001
    STICKY_FAULT_HARDWARE = 10002
    CLEAR_STICKY_FAULT_HARDWARE = 10003
    FAULT_PROC_TEMP = 10004
    STICKY_FAULT_PROC_TEMP = 10005
    CLEAR_STICKY_FAULT_PROC_TEMP = 10006
    FAULT_DEVICE_TEMP = 10007
    STICKY_FAULT_DEVICE_TEMP = 10008
    CLEAR_STICKY_FAULT_DEVICE_TEMP = 10009
    FAULT_UNDERVOLTAGE = 10010
    STICKY_FAULT_UNDERVOLTAGE = 10011
    CLEAR_STICKY_FAULT_UNDERVOLTAGE = 10012
    FAULT_BOOT_DURING_ENABLE = 10013
    STICKY_FAULT_BOOT_DURING_ENABLE = 10014
    CLEAR_STICKY_FAULT_BOOT_DURING_ENABLE = 10015
    FAULT_UNLICENSED_FEATURE_IN_USE = 10016
    STICKY_FAULT_UNLICENSED_FEATURE_IN_USE = 10017
    CLEAR_STICKY_FAULT_UNLICENSED_FEATURE_IN_USE = 10018
    FAULT_PIGEON2_BOOTUP_ACCEL = 10019
    STICKY_FAULT_PIGEON2_BOOTUP_ACCEL = 10020
    CLEAR_STICKY_FAULT_PIGEON2_BOOTUP_ACCEL = 10021
    FAULT_PIGEON2_BOOTUP_GYROS = 10022
    STICKY_FAULT_PIGEON2_BOOTUP_GYROS = 10023
    CLEAR_STICKY_FAULT_PIGEON2_BOOTUP_GYROS = 10024
    FAULT_PIGEON2_BOOTUP_MAGNE = 10025
    STICKY_FAULT_PIGEON2_BOOTUP_MAGNE = 10026
    CLEAR_STICKY_FAULT_PIGEON2_BOOTUP_MAGNE = 10027
    FAULT_PIGEON2_BOOT_INTO_MOTION = 10028
    STICKY_FAULT_PIGEON2_BOOT_INTO_MOTION = 10029
    CLEAR_STICKY_FAULT_PIGEON2_BOOT_INTO_MOTION = 10030
    FAULT_PIGEON2_DATA_ACQUIRED_LATE = 10031
    STICKY_FAULT_PIGEON2_DATA_ACQUIRED_LATE = 10032
    CLEAR_STICKY_FAULT_PIGEON2_DATA_ACQUIRED_LATE = 10033
    FAULT_PIGEON2_LOOP_TIME_SLOW = 10034
    STICKY_FAULT_PIGEON2_LOOP_TIME_SLOW = 10035
    CLEAR_STICKY_FAULT_PIGEON2_LOOP_TIME_SLOW = 10036
    FAULT_PIGEON2_SATURATED_MAGNE = 10037
    STICKY_FAULT_PIGEON2_SATURATED_MAGNE = 10038
    CLEAR_STICKY_FAULT_PIGEON2_SATURATED_MAGNE = 10039
    FAULT_PIGEON2_SATURATED_ACCEL = 10040
    STICKY_FAULT_PIGEON2_SATURATED_ACCEL = 10041
    CLEAR_STICKY_FAULT_PIGEON2_SATURATED_ACCEL = 10042
    FAULT_PIGEON2_SATURATED_GYROS = 10043
    STICKY_FAULT_PIGEON2_SATURATED_GYROS = 10044
    CLEAR_STICKY_FAULT_PIGEON2_SATURATED_GYROS = 10045
    FAULT_CANCODER_BAD_MAGNET = 10046
    STICKY_FAULT_CANCODER_BAD_MAGNET = 10047
    CLEAR_STICKY_FAULT_CANCODER_BAD_MAGNET = 10048
    FAULT_TALONFX_BRIDGE_BROWNOUT = 10049
    STICKY_FAULT_TALONFX_BRIDGE_BROWNOUT = 10050
    CLEAR_STICKY_FAULT_TALONFX_BRIDGE_BROWNOUT = 10051
    FAULT_TALONFX_REMOTE_SENSOR_RESET = 10052
    STICKY_FAULT_TALONFX_REMOTE_SENSOR_RESET = 10053
    CLEAR_STICKY_FAULT_TALONFX_REMOTE_SENSOR_RESET = 10054
    FAULT_TALONFX_MISSING_DIFFERENTIAL_FX = 10055
    STICKY_FAULT_TALONFX_MISSING_DIFFERENTIAL_FX = 10056
    CLEAR_STICKY_FAULT_TALONFX_MISSING_DIFFERENTIAL_FX = 10057
    FAULT_TALONFX_REMOTE_SENSOR_POS_OVERFLOW = 10058
    STICKY_FAULT_TALONFX_REMOTE_SENSOR_POS_OVERFLOW = 10059
    CLEAR_STICKY_FAULT_TALONFX_REMOTE_SENSOR_POS_OVERFLOW = 10060
    FAULT_TALONFX_OVER_SUPPLY_V = 10061
    STICKY_FAULT_TALONFX_OVER_SUPPLY_V = 10062
    CLEAR_STICKY_FAULT_TALONFX_OVER_SUPPLY_V = 10063
    FAULT_TALONFX_UNSTABLE_SUPPLY_V = 10064
    STICKY_FAULT_TALONFX_UNSTABLE_SUPPLY_V = 10065
    CLEAR_STICKY_FAULT_TALONFX_UNSTABLE_SUPPLY_V = 10066
    FAULT_TALONFX_REVERSE_HARD_LIMIT = 10067
    STICKY_FAULT_TALONFX_REVERSE_HARD_LIMIT = 10068
    CLEAR_STICKY_FAULT_TALONFX_REVERSE_HARD_LIMIT = 10069
    FAULT_TALONFX_FORWARD_HARD_LIMIT = 10070
    STICKY_FAULT_TALONFX_FORWARD_HARD_LIMIT = 10071
    CLEAR_STICKY_FAULT_TALONFX_FORWARD_HARD_LIMIT = 10072
    FAULT_TALONFX_REVERSE_SOFT_LIMIT = 10073
    STICKY_FAULT_TALONFX_REVERSE_SOFT_LIMIT = 10074
    CLEAR_STICKY_FAULT_TALONFX_REVERSE_SOFT_LIMIT = 10075
    FAULT_TALONFX_FORWARD_SOFT_LIMIT = 10076
    STICKY_FAULT_TALONFX_FORWARD_SOFT_LIMIT = 10077
    CLEAR_STICKY_FAULT_TALONFX_FORWARD_SOFT_LIMIT = 10078
    FAULT_TALONFX_MISSING_REM_SOFT_LIM = 10079
    STICKY_FAULT_TALONFX_MISSING_REM_SOFT_LIM = 10080
    CLEAR_STICKY_FAULT_TALONFX_MISSING_REM_SOFT_LIM = 10081
    FAULT_TALONFX_MISSING_REM_HARD_LIM = 10082
    STICKY_FAULT_TALONFX_MISSING_REM_HARD_LIM = 10083
    CLEAR_STICKY_FAULT_TALONFX_MISSING_REM_HARD_LIM = 10084
    FAULT_TALONFX_MISSING_REMOTE_SENSOR = 10085
    STICKY_FAULT_TALONFX_MISSING_REMOTE_SENSOR = 10086
    CLEAR_STICKY_FAULT_TALONFX_MISSING_REMOTE_SENSOR = 10087
    FAULT_TALONFX_FUSED_SENSOR_OUT_OF_SYNC = 10088
    STICKY_FAULT_TALONFX_FUSED_SENSOR_OUT_OF_SYNC = 10089
    CLEAR_STICKY_FAULT_TALONFX_FUSED_SENSOR_OUT_OF_SYNC = 10090
    FAULT_TALONFX_STATOR_CURR_LIMIT = 10091
    STICKY_FAULT_TALONFX_STATOR_CURR_LIMIT = 10092
    CLEAR_STICKY_FAULT_TALONFX_STATOR_CURR_LIMIT = 10093
    FAULT_TALONFX_SUPPLY_CURR_LIMIT = 10094
    STICKY_FAULT_TALONFX_SUPPLY_CURR_LIMIT = 10095
    CLEAR_STICKY_FAULT_TALONFX_SUPPLY_CURR_LIMIT = 10096
    FAULT_TALONFX_USING_FUSED_CC_WHILE_UNLICENSED = 10097
    STICKY_FAULT_TALONFX_USING_FUSED_CC_WHILE_UNLICENSED = 10098
    CLEAR_STICKY_FAULT_TALONFX_USING_FUSED_CC_WHILE_UNLICENSED = 10099
    FAULT_TALONFX_STATIC_BRAKE_DISABLED = 10100
    STICKY_FAULT_TALONFX_STATIC_BRAKE_DISABLED = 10101
    CLEAR_STICKY_FAULT_TALONFX_STATIC_BRAKE_DISABLED = 10102
    FAULT_TALONFX_BRIDGE_SHORT = 10103
    STICKY_FAULT_TALONFX_BRIDGE_SHORT = 10104
    CLEAR_STICKY_FAULT_TALONFX_BRIDGE_SHORT = 10105
    FAULT_TALONFX_HALL_SENSOR_MISSING = 10106
    STICKY_FAULT_TALONFX_HALL_SENSOR_MISSING = 10107
    CLEAR_STICKY_FAULT_TALONFX_HALL_SENSOR_MISSING = 10108
    FAULT_TALONFX_DRIVE_DISABLED_HALL_SENSOR = 10109
    STICKY_FAULT_TALONFX_DRIVE_DISABLED_HALL_SENSOR = 10110
    CLEAR_STICKY_FAULT_TALONFX_DRIVE_DISABLED_HALL_SENSOR = 10111
    FAULT_TALONFX_MOTOR_TEMP_SENSOR_MISSING = 10112
    STICKY_FAULT_TALONFX_MOTOR_TEMP_SENSOR_MISSING = 10113
    CLEAR_STICKY_FAULT_TALONFX_MOTOR_TEMP_SENSOR_MISSING = 10114
    FAULT_TALONFX_MOTOR_TEMP_SENSOR_TOO_HOT = 10115
    STICKY_FAULT_TALONFX_MOTOR_TEMP_SENSOR_TOO_HOT = 10116
    CLEAR_STICKY_FAULT_TALONFX_MOTOR_TEMP_SENSOR_TOO_HOT = 10117
    FAULT_CANDI_5_V = 10118
    STICKY_FAULT_CANDI_5_V = 10119
    CLEAR_STICKY_FAULT_CANDI_5_V = 10120
    FAULT_CANDLE_OVERVOLTAGE = 10124
    STICKY_FAULT_CANDLE_OVERVOLTAGE = 10125
    CLEAR_STICKY_FAULT_CANDLE_OVERVOLTAGE = 10126
    FAULT_CANDLE_5_V_TOO_HIGH = 10127
    STICKY_FAULT_CANDLE_5_V_TOO_HIGH = 10128
    CLEAR_STICKY_FAULT_CANDLE_5_V_TOO_HIGH = 10129
    FAULT_CANDLE_5_V_TOO_LOW = 10130
    STICKY_FAULT_CANDLE_5_V_TOO_LOW = 10131
    CLEAR_STICKY_FAULT_CANDLE_5_V_TOO_LOW = 10132
    FAULT_CANDLE_THERMAL = 10133
    STICKY_FAULT_CANDLE_THERMAL = 10134
    CLEAR_STICKY_FAULT_CANDLE_THERMAL = 10135
    FAULT_CANDLE_SOFTWARE_FUSE = 10136
    STICKY_FAULT_CANDLE_SOFTWARE_FUSE = 10137
    CLEAR_STICKY_FAULT_CANDLE_SOFTWARE_FUSE = 10138
    FAULT_CANDLE_SHORT_CIRCUIT = 10139
    STICKY_FAULT_CANDLE_SHORT_CIRCUIT = 10140
    CLEAR_STICKY_FAULT_CANDLE_SHORT_CIRCUIT = 10141